<?php
namespace Elbotrade\Bundle\CatalogBundle\Controller;

use Symfony\Component\HttpFoundation\Request;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Template;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;

class CatalogCategoryBackendController extends CatalogCategoryController
{

    /**
     * @Route("/elbotrade/catalog-cateogry/backend/list", name="elbotrade_catalog_category_backend_list")
     * @Template()
     */
    public function indexAction()
    {

        return parent::indexAction(); // TODO: Change the autogenerated stub
    }

    /**
     * @Route("/elbotrade/catalog-cateogry/backend/show/{id}", name="elbotrade_catalog_category_backend_show")
     * @Template()
     */
    public function showAction($id)
    {
        return parent::showAction($id); // TODO: Change the autogenerated stub
    }

    /**
     * @param Request $request
     * @return array
     * @Route("/elbotrade/catalog-cateogry/backend/create", name="elbotrade_catalog_category_backend_create")
     * @Template();
     */
    public function createAction(Request $request)
    {

        $catalogCategoryManager = $this->get('elbotrade.catalog.catalog_category_manager');

        $catalogCategory = $catalogCategoryManager->createCatalogCategory();

        $form = $this->createForm(
            $this->get('elbotrade_catalog.catalog_category.form.type'), null, ['action' => $this->generateUrl('elbotrade_catalog_category_backend_create')]
        );

        if ($request->isMethod(Request::METHOD_POST)) {
            $catalogCategoryManager = $this->get('elbotrade.catalog.catalog_category_manager');
            if ($catalogCategoryId = $catalogCategoryManager->handleCatalogCategoryForm($form, $catalogCategory, $request, $this->get('sylius.context.locale')->getCurrentLocale())) {
                $response = $this->redirect($this->generateUrl('elbotrade_catalog_category_backend_list', ['id' => $catalogCategoryId]));
                return $response;
            }
        }

        $form->setData($catalogCategory);

        return [
            'form' => $form->createView(),
        ];

    }

    /**
     * @param Request $request
     * @param $id
     * @Route("/elbotrade/catalog-cateogry/backend/update/{id}", name="elbotrade_catalog_category_backend_update")
     * @Template()
     * @return array|\Symfony\Component\HttpFoundation\RedirectResponse
     */
    public function updateAction(Request $request, $id)
    {

        $catalogCategoryFinder = $this->get('elbotrade.catalog.catalog_category_finder');

        $catalogCategory = $catalogCategoryFinder->findCatalogCategory($id);

        $form = $this->createForm(
            $this->get('elbotrade_catalog.catalog_category.form.type'), null, ['action' => $this->generateUrl('elbotrade_catalog_category_backend_update', ['id' => $id])]
        );

        if ($request->isMethod(Request::METHOD_POST)) {
            $catalogCategoryManager = $this->get('elbotrade.catalog.catalog_category_manager');
            if ($catalogCategoryId = $catalogCategoryManager->handleCatalogCategoryForm($form, $catalogCategory, $request, $this->get('sylius.context.locale')->getCurrentLocale())) {
                $response = $this->redirect($this->generateUrl('elbotrade_catalog_category_backend_show', ['id' => $catalogCategoryId]));
                return $response;
            }
        }

        $form->setData($catalogCategory);

        return [
            'form' => $form->createView(),
//            'images' => $catalogCategory->getImage() ? $catalogCategory->getImage() : [],
        ];

    }

    /**
     * @Route("/elbotrade/catalog-cateogry/backend/delete/{id}", name="elbotrade_catalog_category_backend_delete")
     */
    public function deleteAction($id)
    {

        $catalogCategory = $this->get('elbotrade.catalog.catalog_category_finder')->findCatalogCategory($id);

        $this->getDoctrine()->getManager()->remove($catalogCategory);
        $this->getDoctrine()->getManager()->flush();

        $flashService = $this->get('elbotrade_product.services.flash_service');

        $flashService->setFlash('success', 'Catalog category Deleted');

        return $this->redirect($this->generateUrl('elbotrade_catalog_category_backend_list'));
    }
}